# Class: TileSprite

## Phaser. TileSprite

Phaser.TileSprite

#### new TileSprite(game, x, y, width, height, key, frame)

  A TileSprite is a Sprite that has a repeating texture. The texture can be scrolled and scaled and will automatically wrap on the edges as it does so. Please note that TileSprites, as with normal Sprites, have no input handler or physics bodies by default. Both need enabling.

  ##### Parameters:

  Name | Type | Description
  --- | --- | ---
  `game` | Phaser.Game | A reference to the currently running game.
  `x` | number | The x coordinate (in world space) to position the TileSprite at.
  `y` | number | The y coordinate (in world space) to position the TileSprite at.
  `width` | number | The width of the TileSprite.
  `height` | number | The height of the TileSprite.
  `key` | string | Phaser.RenderTexture | Phaser.BitmapData | PIXI.Texture | This is the image or texture used by the TileSprite during rendering. It can be a string which is a reference to the Cache entry, or an instance of a RenderTexture or PIXI.Texture.
  `frame` | string | number | If this TileSprite is using part of a sprite sheet or texture atlas you can specify the exact frame to use by giving a string or numeric index.

  Source:
    - gameobjects/TileSprite.js, line 21

### Members

#### angle

  Indicates the rotation of the Sprite, in degrees, from its original orientation. Values from 0 to 180 represent clockwise rotation; values from 0 to -180 represent counterclockwise rotation. Values outside this range are added to or subtracted from 360 to obtain a value within the range. For example, the statement player.angle = 450 is the same as player.angle = 90. If you wish to work in radians instead of degrees use the property Sprite.rotation instead. Working in radians is also a little faster as it doesn't have to convert the angle.

  ##### Properties:

  Name | Type | Description
  --- | --- | ---
  `angle` | number | The angle of this Sprite in degrees.

  Source:
    - gameobjects/TileSprite.js, line 515

#### animations

  ##### Properties:

  Name | Type | Description
  --- | --- | ---
  `animations` | Phaser.AnimationManager | This manages animations of the sprite. You can modify animations through it (see Phaser.AnimationManager)

  Source:
    - gameobjects/TileSprite.js, line 60

#### autoCull

  Should this Sprite be automatically culled if out of range of the camera? A culled sprite has its renderable property set to 'false'. Be advised this is quite an expensive operation, as it has to calculate the bounds of the object every frame, so only enable it if you really need it.

  ##### Properties:

  Name | Type | Description
  --- | --- | ---
  `autoCull` | boolean | A flag indicating if the Sprite should be automatically camera culled or not.

  Default Value:
    - false
  Source:
    - gameobjects/TileSprite.js, line 109

#### body

  By default Sprites won't add themselves to any physics system and their physics body will be `null`. To enable them for physics you need to call `game.physics.enable(sprite, system)` where `sprite` is this object and `system` is the Physics system you want to use to manage this body. Once enabled you can access all physics related properties via `Sprite.body`.

  Important: Enabling a Sprite for P2 or Ninja physics will automatically set `Sprite.anchor` to 0.5 so the physics body is centered on the Sprite. If you need a different result then adjust or re-create the Body shape offsets manually, and/or reset the anchor after enabling physics.

  ##### Properties:

  Name | Type | Description
  --- | --- | ---
  `body` | Phaser.Physics.Arcade.Body | Phaser.Physics.P2.Body | Phaser.Physics.Ninja.Body | null |

  Default Value:
    - null
  Source:
    - gameobjects/TileSprite.js, line 136

#### cameraOffset

  ##### Properties:

  Name | Type | Description
  --- | --- | ---
  `cameraOffset` | Phaser.Point | If this object is fixedToCamera then this stores the x/y offset that its drawn at, from the top-left of the camera view.

  Source:
    - gameobjects/TileSprite.js, line 123

#### checkWorldBounds

  If true the Sprite checks if it is still within the world each frame, when it leaves the world it dispatches Sprite.events.onOutOfBounds and optionally kills the sprite (if Sprite.outOfBoundsKill is true). By default this is disabled because the Sprite has to calculate its bounds every frame to support it, and not all games need it. Enable it by setting the value to true.

  ##### Properties:

  Name | Type | Description
  --- | --- | ---
  `checkWorldBounds` | boolean |

  Default Value:
    - false
  Source:
    - gameobjects/TileSprite.js, line 118

#### destroyPhase

  ##### Properties:

  Name | Type | Description
  --- | --- | ---
  `destroyPhase` | boolean | True if this object is currently being destroyed.

  Source:
    - gameobjects/TileSprite.js, line 754

#### events

  ##### Properties:

  Name | Type | Description
  --- | --- | ---
  `events` | Phaser.Events | The Events you can subscribe to that are dispatched when certain things happen on this Sprite or its components.

  Source:
    - gameobjects/TileSprite.js, line 55

#### exists

  TileSprite.exists controls if the core game loop and physics update this TileSprite or not. When you set TileSprite.exists to false it will remove its Body from the physics world (if it has one) and also set TileSprite.visible to false. Setting TileSprite.exists to true will re-add the Body to the physics world (if it has a body) and set TileSprite.visible to true.

  ##### Properties:

  Name | Type | Description
  --- | --- | ---
  `exists` | boolean | If the TileSprite is processed by the core game update and physics.

  Source:
    - gameobjects/TileSprite.js, line 612

#### fixedToCamera

  An TileSprite that is fixed to the camera uses its x/y coordinates as offsets from the top left of the camera. These are stored in TileSprite.cameraOffset. Note that the cameraOffset values are in addition to any parent in the display list. So if this TileSprite was in a Group that has x: 200, then this will be added to the cameraOffset.x

  ##### Properties:

  Name | Type | Description
  --- | --- | ---
  `fixedToCamera` | boolean | Set to true to fix this TileSprite to the Camera at its current world coordinates.

  Source:
    - gameobjects/TileSprite.js, line 581

#### frame

  ##### Properties:

  Name | Type | Description
  --- | --- | ---
  `frame` | number | Gets or sets the current frame index and updates the Texture Cache for display.

  Source:
    - gameobjects/TileSprite.js, line 539

#### frameName

  ##### Properties:

  Name | Type | Description
  --- | --- | ---
  `frameName` | string | Gets or sets the current frame name and updates the Texture Cache for display.

  Source:
    - gameobjects/TileSprite.js, line 560

#### game

  ##### Properties:

  Name | Type | Description
  --- | --- | ---
  `game` | Phaser.Game | A reference to the currently running Game.

  Source:
    - gameobjects/TileSprite.js, line 33

#### input

  ##### Properties:

  Name | Type | Description
  --- | --- | ---
  `input` | Phaser.InputHandler | null | The Input Handler for this object. Needs to be enabled with image.inputEnabled = true before you can use it.

  Source:
    - gameobjects/TileSprite.js, line 94

#### inputEnabled

  By default a TileSprite won't process any input events at all. By setting inputEnabled to true the Phaser.InputHandler is activated for this object and it will then start to process click/touch events and more.

  ##### Properties:

  Name | Type | Description
  --- | --- | ---
  `inputEnabled` | boolean | Set to true to allow this object to receive input events.

  Source:
    - gameobjects/TileSprite.js, line 659

#### key

  ##### Properties:

  Name | Type | Description
  --- | --- | ---
  `key` | string | Phaser.RenderTexture | Phaser.BitmapData | PIXI.Texture | This is the image or texture used by the Sprite during rendering. It can be a string which is a reference to the Cache entry, or an instance of a RenderTexture, BitmapData or PIXI.Texture.

  Source:
    - gameobjects/TileSprite.js, line 65

#### name

  ##### Properties:

  Name | Type | Description
  --- | --- | ---
  `name` | string | The user defined name given to this Sprite.

  Source:
    - gameobjects/TileSprite.js, line 39

#### <readonly> type

  ##### Properties:

  Name | Type | Description
  --- | --- | ---
  `type` | number | The const type of this object.

  Source:
    - gameobjects/TileSprite.js, line 45

#### world

  ##### Properties:

  Name | Type | Description
  --- | --- | ---
  `world` | Phaser.Point | The world coordinates of this Sprite. This differs from the x/y coordinates which are relative to the Sprites container.

  Source:
    - gameobjects/TileSprite.js, line 99

#### x

  The position of the TileSprite on the x axis relative to the local coordinates of the parent.

  ##### Properties:

  Name | Type | Description
  --- | --- | ---
  `x` | number | The position of the TileSprite on the x axis relative to the local coordinates of the parent.

  Source:
    - gameobjects/TileSprite.js, line 700

#### y

  The position of the TileSprite on the y axis relative to the local coordinates of the parent.

  ##### Properties:

  Name | Type | Description
  --- | --- | ---
  `y` | number | The position of the TileSprite on the y axis relative to the local coordinates of the parent.

  Source:
    - gameobjects/TileSprite.js, line 727

#### z

  ##### Properties:

  Name | Type | Description
  --- | --- | ---
  `z` | number | The z-depth value of this object within its Group (remember the World is a Group as well). No two objects in a Group can have the same z value.

  Source:
    - gameobjects/TileSprite.js, line 50

### Methods

#### autoScroll()

  Sets this TileSprite to automatically scroll in the given direction until stopped via TileSprite.stopScroll(). The scroll speed is specified in pixels per second. A negative x value will scroll to the left. A positive x value will scroll to the right. A negative y value will scroll up. A positive y value will scroll down.

  Source:
    - gameobjects/TileSprite.js, line 297

#### destroy(destroyChildren)

  Destroys the TileSprite. This removes it from its parent group, destroys the event and animation handlers if present and nulls its reference to game, freeing it up for garbage collection.

  ##### Parameters:

  Name | Type | Argument | Default | Description
  --- | --- | --- | --- | ---
  `destroyChildren` | boolean | <optional> | true | Should every child of this object have its destroy method called?

  Source:
    - gameobjects/TileSprite.js, line 396

#### loadTexture(key, frame)

  Changes the Texture the TileSprite is using entirely. The old texture is removed and the new one is referenced or fetched from the Cache. This causes a WebGL texture update, so use sparingly or in low-intensity portions of your game.

  ##### Parameters:

  Name | Type | Description
  --- | --- | ---
  `key` | string | Phaser.RenderTexture | Phaser.BitmapData | PIXI.Texture | This is the image or texture used by the Sprite during rendering. It can be a string which is a reference to the Cache entry, or an instance of a RenderTexture, BitmapData or PIXI.Texture.
  `frame` | string | number | If this Sprite is using part of a sprite sheet or texture atlas you can specify the exact frame to use by giving a string or numeric index.

  Source:
    - gameobjects/TileSprite.js, line 324

#### play(name, frameRate, loop, killOnComplete) → {Phaser.Animation}

  Play an animation based on the given key. The animation should previously have been added via sprite.animations.add() If the requested animation is already playing this request will be ignored. If you need to reset an already running animation do so directly on the Animation object itself.

  ##### Parameters:

  Name | Type | Argument | Default | Description
  --- | --- | --- | --- | ---
  `name` | string |  |  | The name of the animation to be played, e.g. "fire", "walk", "jump".
  `frameRate` | number | <optional> | null | The framerate to play the animation at. The speed is given in frames per second. If not provided the previously set frameRate of the Animation is used.
  `loop` | boolean | <optional> | false | Should the animation be looped after playback. If not provided the previously set loop value of the Animation is used.
  `killOnComplete` | boolean | <optional> | false | If set to true when the animation completes (only happens if loop=false) the parent Sprite will be killed.

  Source:
    - gameobjects/TileSprite.js, line 461

  ##### Returns:

  A reference to playing Animation instance.

  Type
    Phaser.Animation

#### postUpdate()

  Internal function called by the World postUpdate cycle.

  Source:
    - gameobjects/TileSprite.js, line 269

#### preUpdate()

  Automatically called by World.preUpdate.

  Source:
    - gameobjects/TileSprite.js, line 159

#### reset(x, y)

  Resets the TileSprite. This places the TileSprite at the given x/y world coordinates, resets the tilePosition and then sets alive, exists, visible and renderable all to true. Also resets the outOfBounds state. If the TileSprite has a physics body that too is reset.

  ##### Parameters:

  Name | Type | Description
  --- | --- | ---
  `x` | number | The x coordinate (in world space) to position the Sprite at.
  `y` | number | The y coordinate (in world space) to position the Sprite at.

  Source:
    - gameobjects/TileSprite.js, line 479

  ##### Returns:

  (Phaser.TileSprite) This instance.

#### stopScroll()

  Stops an automatically scrolling TileSprite.

  Source:
    - gameobjects/TileSprite.js, line 312

#### update()

  Override and use this function in your own custom objects to handle any update requirements you may have.

  Source:
    - gameobjects/TileSprite.js, line 259